#include <3048F.H>
#include <STRING.H>

void print_i(int data);
void print(char disp_data[16]);
void LCD_init(void);
void LCD_out8(char data, char RS);
void LCD_out4(char data, char RS);
void wait_4m(void);
void wait(unsigned char count);
void wait_1m(void);


void main(void)
{
unsigned char i, j, out_data;

	/*|[g1,2,3,5o͂ɐݒ*/
	P1.DDR = 0xff;
	P2.DDR = 0xff;
	P3.DDR = 0xff;
	P5.DDR = 0xff;

	/*|[g4͂ɐݒ*/
	P4.DDR = 0x00;
	P4.PCR.BYTE = 0xff;/*vAbv*/


	ITU1.TCR.BYTE = 0x23;
	ITU1.GRA = 800;

	ITU2.TCR.BYTE = 0x23;
	ITU2.GRA = 8000;		/*4.0m sec*/

	LCD_init();
	print("Sig. Distri. PGM");

	while(1)
	{
		out_data = 1;

		/*X^[gMǂݎ ~_~~~~~~*/
		while(P4.DR.BIT.B3 == 1);
		P1.DR.BYTE = out_data;
		P2.DR.BYTE = out_data;
		P3.DR.BYTE = out_data;
		while(P4.DR.BIT.B3 == 0);


		/*Mǂݎ ~_~~~~~~ch0, 8, 16*/
		i = 3;
		do{
			if(P4.DR.BIT.B0 == 1 && P1.DR.BYTE != 0)
			{
				i--;
				P1.DR.BYTE = 0;
			}
			if(P4.DR.BIT.B1 == 1 && P2.DR.BYTE != 0)
			{
				i--;
				P2.DR.BYTE = 0;
			}
			if(P4.DR.BIT.B2 == 1 && P3.DR.BYTE != 0)
			{
				i--;
				P3.DR.BYTE = 0;
			}
		}while(i > 0);

		for(j = 1; j < 8; j++)
		{
			/*o̓f[^Vtg*/
			out_data = out_data * 2;
		
			/*Mǂݎ ~_~~~~~~*/
			while(P4.DR.BIT.B0 == 1);
			P1.DR.BYTE = out_data;
			P2.DR.BYTE = out_data;
			P3.DR.BYTE = out_data;

			i = 3;
			do{
				if(P4.DR.BIT.B0 == 1 && P1.DR.BYTE != 0)
				{
					i--;
					P1.DR.BYTE = 0;
				}
				if(P4.DR.BIT.B1 == 1 && P2.DR.BYTE != 0)
				{
					i--;
					P2.DR.BYTE = 0;
				}
				if(P4.DR.BIT.B2 == 1 && P3.DR.BYTE != 0)
				{
					i--;
					P3.DR.BYTE = 0;
				}
			}while(i > 0);
		}
	}
}
/*********************************************************************/
/**  O`QTT܂ł̐i߂Ńvg                 **/
/*********************************************************************/
void print_i(int data)
{
unsigned char	j;
char			string[16];

	/* Clear screen */
	LCD_out4(0x01, 0);
	wait_4m();

	/*100̈*/
	j = (unsigned char)(data / 100);
	if(j != 0) string[0] = 0x30 + j;
	else	   string[0] = 0x20;
	
	/*10̈*/
	data = data - (int)j * 100;
	j = (unsigned char)(data / 10);
	if(j != 0) string[1] = 0x30 + j;
	else	   string[1] = 0x20;
	
	/*1̈*/
	data = data - (int)j * 10;
	j = (unsigned char)data;	
	string[2] = 0x30 + j;

	string[3] = 0;

	print(string);
	return;
}
/*********************************************************************/
void print(char disp_data[16])
{
char	i, j;

	/*̏INA*/
	for(i = 0; i < 16; i++)
	{
		if(disp_data[i] == 0)
		{
			for(j = i; j < 16; j++)
			{
				disp_data[j] = 0x20;
			}
			break;
		}
	}

	/* Clear screen */
	/*
	LCD_out4(0x01, 0);
	wait_4m();
	*/

	for(i = 0; i < 16; i++)
	{
		LCD_out4(disp_data[i], 1);
		wait_4m();
	}

	return;
}
/*********************************************************************/
void LCD_init(void)
{
unsigned char c, RS;

	/* LCD̏*/
	wait_4m();
	wait_4m();
	wait_4m();
	wait_4m();

	RS = 0;/*command mode*/
	/*LCD t@NVZbgP*/
	c = 0x03;
	LCD_out8(c, RS);

	/*LCD t@NVZbg2*/
	c = 0x03;
	LCD_out8(c, RS);

	/*LCD t@NVZbg3*/
	c = 0x03;
	LCD_out8(c, RS);

	/*LCD t@NVZbg*/
	c = 0x02;
	LCD_out8(c, RS);

	/*ݒ********************************************/
	c = 0x28;
	LCD_out4(c, RS);

	c = 0x08;
	LCD_out4(c, RS);/*\It*/

	c = 0x01;
	LCD_out4(c, RS);/*\I*/

	c = 0x06;
	LCD_out4(c, RS);/*Gg[[h*/

	c = 0x0f;
	LCD_out4(c, RS);/*ON*/

	c = 0x01;
	LCD_out4(c, RS);/*\NA*/

	c = 0x02;
	LCD_out4(c, RS);/*J[\z[*/

}
/*********************************************************************/
void LCD_out8(char data, char RS)
{
char i, j;

	if(RS > 0) P3.DR.BIT.B4 = 1;/*RSMZbg*/
	else  P3.DR.BIT.B4 = 0;

	i = P3.DR.BYTE & 0xf0;
	j = data & 0x0f;
	i = i | j;
	P3.DR.BYTE = data;/*R}h@/@f[^o*/
	
	P3.DR.BIT.B5 = 1;/*EMZbg*/
	wait_4m();
	P3.DR.BIT.B5 = 0;/*EMZbg*/
	wait_4m();
	
}
/*********************************************************************/
/*^ꂽWbit̃f[^ʁ|ʏ4bit2ɕď*/
void LCD_out4(char data, char RS)
{
char i, j;

	if(RS > 0) P3.DR.BIT.B4 = 1;/*RSMZbg*/
	else  P3.DR.BIT.B4 = 0;

	/**ʃf[^o******/

	i = P3.DR.BYTE & 0xf0;
	j = (data / 16) & 0x0f;
	i = i | j;
	P3.DR.BYTE = i;/*R}ho*/

	P3.DR.BIT.B5 = 1;/*EMZbg*/
	wait_4m();
	P3.DR.BIT.B5 = 0;/*EMZbg*/
	wait_4m();

	/**ʃf[^o****************************************/
	i = P3.DR.BYTE & 0xf0;
	j = data & 0x0f;
	i = i | j;
	P3.DR.BYTE = i;/*R}ho*/

	P3.DR.BIT.B5 = 1;/*EMZbg*/
	wait_4m();
	P3.DR.BIT.B5 = 0;/*EMZbg*/
	wait_4m();
}
/*************************************************************/
/**  4m sec̊ԑ҂                          **/
/*************************************************************/
void wait_4m(void)
{
unsigned char c, fl;

	ITU.TSTR.BIT.STR2 = 1;
	fl = 1;
	while(fl == 1)
	{
		c = ITU2.TSR.BYTE & 0x01;
		if(c == 1)
		{
			c = ITU2.TSR.BYTE;
			ITU2.TSR.BYTE = c & 0xfe;
			fl = 0;
		}
	}
	ITU.TSTR.BIT.STR2 = 0;
	return;
}
/*************************************************************/
/**  ҂ count = 250 ŖPb@@                          **/
/*************************************************************/
void wait(unsigned char count)
{
unsigned char i;

	for(i = 0; i < count; i++)
	{
		wait_4m();
	}
	return;
}
/*************************************************************/
/**  0.6m sec̊ԑ҂                                       **/
/*************************************************************/
void wait_1m(void)
{
unsigned char c, fl;

	ITU.TSTR.BIT.STR1 = 1;
	fl = 1;
	while(fl == 1)
	{
		c = ITU1.TSR.BYTE & 0x01;
		if(c == 1)
		{
			c = ITU1.TSR.BYTE;
			ITU1.TSR.BYTE = c & 0xfe;
			fl = 0;
		}
	}
	ITU.TSTR.BIT.STR1 = 0;
	return;
}